//: C08:CheckedCast2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Používá operátor dynamic_cast.
#include <vector>
#include "../purge.h"
#include "Security.h"
using namespace std;

int main() {
  vector<Ceniny*> portfolio;
  portfolio.push_back(new Kov);
  portfolio.push_back(new Investice);
  portfolio.push_back(new Obligace);
  portfolio.push_back(new Akcie);
  for(vector<Ceniny*>::iterator it =
       portfolio.begin();
       it != portfolio.end(); ++it) {
    Investice* cm = dynamic_cast<Investice*>(*it);
    if(cm)
      cm->special();
    else
      cout << "není Investice" << endl;
  }
  cout << "přetypování z mezilehlého ukazatele:" << endl;
  Ceniny* sp = new Kov;
  Investice* cp = dynamic_cast<Investice*>(sp);
  if(cp) cout << "  je to Investice" << endl;
  Kov* mp = dynamic_cast<Kov*>(sp);
  if(mp) cout << "  je to i Kov!" << endl;
  purge(portfolio);
} ///:~
